import { Component } from "../TSX/TSX";
import { BasicEvent, EventInterface } from "@h4x/common";
export declare type $Proxy<T> = {
    get: () => T;
    set: (variable: T) => void;
    onUpdate: BasicEvent<(value?: T) => void>;
    onChange: BasicEvent<(value?: T) => void>;
};
export declare abstract class BasicComponent<P = {}> extends Component<P> {
    private attachedEventReferences;
    protected onDestroy: BasicEvent<() => void, () => void>;
    constructor();
    proxy<K extends keyof this = keyof this>(key: K): $Proxy<this[K]>;
    $<K extends keyof this = keyof this>(key: K): $Proxy<this[K]>;
    static var(): (target: any, key: string) => void;
    static bind<T extends BasicComponent<any>>(): (target: T, key: string) => void;
    static interval<T extends BasicComponent<any>>(time: number): (target: T, key: string) => void;
    static initialize<T extends BasicComponent<any>>(): (target: T, key: string) => void;
    private __init;
    private __destroy;
    /** Attach event reference to be cleaned up when the object is destroyed */
    protected ref<T extends EventInterface<any, any>>(ref: T): T;
    static normalizeClass(target: any): undefined | {
        [K: string]: boolean;
    };
    static mergeClasses(...target: (string | {
        [K: string]: boolean | undefined;
    } | (string | false | undefined | null)[] | undefined)[]): undefined | {
        [K: string]: boolean;
    };
}
