import { $Proxy, BasicComponent } from "../Components/BasicComponent";
export interface InputProps<T> extends JSX.HTMLAttributes<HTMLInputElement> {
    $: $Proxy<T>;
    value?: undefined;
    onInput?: undefined;
    onChange?: undefined;
}
export declare abstract class BasicInput<T extends {
    $: $Proxy<any>;
}> extends BasicComponent<T> {
    init(): void;
    destroy(): void;
    willReceiveProps(): void;
}
export declare class InputText extends BasicInput<InputProps<string>> {
    protected onInput(event: any): void;
    protected onChange(event: any): void;
    render(): JSX.Element;
}
export declare class InputNumber extends BasicInput<InputProps<number>> {
    protected onInput(event: any): void;
    protected onChange(event: any): void;
    render(): JSX.Element;
}
export declare class InputRange extends BasicInput<InputProps<number>> {
    protected onInput(event: any): void;
    protected onChange(event: any): void;
    render(): JSX.Element;
}
export interface InputTextBoxProps<T> extends JSX.HTMLAttributes<HTMLTextAreaElement> {
    $: $Proxy<T>;
    handleTabs?: boolean;
    value?: undefined;
    onInput?: undefined;
}
export declare class InputTextBox extends BasicInput<InputTextBoxProps<string>> {
    protected onInput(event: any): void;
    protected onChange(event: any): void;
    protected onKeyDown(event: KeyboardEvent, input: HTMLTextAreaElement): boolean;
    render(): JSX.Element;
}
export declare class InputCheckbox extends BasicInput<InputProps<boolean>> {
    protected onInput(event: any): void;
    protected onChange(event: any): void;
    render(): JSX.Element;
}
export declare class BasicText extends BasicInput<InputProps<string | number>> {
    render(): JSX.Element;
}
export declare class FixedNumber extends BasicInput<InputProps<number> & {
    digits: number;
    multiplier?: number;
    prefix?: string;
    postfix?: string;
}> {
    render(): JSX.Element;
}
export interface SelectProps<T> extends JSX.HTMLAttributes<HTMLSelectElement> {
    $: $Proxy<T>;
    value?: undefined;
    onInput?: undefined;
    onChange?: undefined;
}
export declare class InputSelect extends BasicInput<{
    values: {
        [K: string]: string;
    } | string[];
} & SelectProps<string>> {
    protected onInput(event: any): void;
    protected onChange(event: any): void;
    render(): JSX.Element;
}
export declare class InputFile extends BasicComponent<{
    onFile: (file: File | undefined) => void;
} & JSX.HTMLAttributes<HTMLInputElement>> {
    protected onChange(event: {
        target: HTMLInputElement;
    }): void;
    render(): JSX.Element;
}
export declare class InputFiles extends BasicComponent<{
    onFiles: (files: File[] | undefined) => void;
} & JSX.HTMLAttributes<HTMLInputElement>> {
    protected onChange(event: {
        target: HTMLInputElement;
    }): void;
    render(): JSX.Element;
}
