import { Component, TSX } from "../TSX/TSX";
import { BasicComponent } from "./BasicComponent";
declare const $remove: unique symbol;
declare const $rendered: unique symbol;
declare const $attach: unique symbol;
export declare abstract class Fragment<T> extends BasicComponent<T & {
    fragmentList: Fragment.AbstractList<Fragment<T>>;
}> {
    [$rendered]: TSX.RenderedComponent<Fragment<T>>;
    remove(): void;
    onDetached(): void;
}
export declare namespace Fragment {
    abstract class AbstractList<T extends Fragment<any>> {
        protected component: Container<T>;
        abstract [Symbol.iterator](): Iterator<TSX.RenderedComponent<T>>;
        instances(): Generator<T, void, unknown>;
        abstract get first(): TSX.RenderedComponent<T> | undefined;
        abstract get firstInstance(): T | undefined;
        abstract get last(): TSX.RenderedComponent<T> | undefined;
        abstract get lastInstance(): T | undefined;
        abstract get length(): number;
        abstract indexOf(rendered: TSX.RenderedComponent<T> | T): number;
        protected createFragment<K extends T>(FragmentClass: new () => K, args: Omit<TSX.Props<K>, "fragmentList">): {
            rendered: TSX.RenderedComponent<T>;
            instance: K;
        };
        [$attach](component: Container<T>): void;
        abstract [$remove](rendered: TSX.RenderedComponent<T>): boolean;
    }
    class List<T extends Fragment<any>> extends AbstractList<T> {
        private readonly fragments;
        get length(): number;
        get first(): TSX.RenderedComponent<T>;
        get firstInstance(): T;
        get last(): TSX.RenderedComponent<T>;
        get lastInstance(): T;
        [Symbol.iterator](): Generator<TSX.RenderedComponent<T>, void, unknown>;
        get(at: number): TSX.RenderedComponent<T>;
        getInstance(at: number): T;
        indexOf(rendered: TSX.RenderedComponent<T> | T): number;
        /** Add fragment before `at` or at the end */
        addFragment<K extends T>(FragmentClass: new () => K, args: Omit<TSX.Props<K>, "fragmentList">, at?: number | T): K;
        moveFragment(rendered: TSX.RenderedComponent<T>, to?: number): void;
        detachFragment(rendered: TSX.RenderedComponent<T>): boolean;
        detachAll(): void;
        destroyAll(): void;
        [$attach](component: Container<T>): void;
        /** internal */
        [$remove](rendered: TSX.RenderedComponent<T>): boolean;
    }
    class Single<T extends Fragment<any>> extends AbstractList<T> {
        private fragment?;
        get length(): 1 | 0;
        get first(): TSX.RenderedComponent<T> | undefined;
        get firstInstance(): T | undefined;
        get last(): TSX.RenderedComponent<T> | undefined;
        get lastInstance(): T | undefined;
        [Symbol.iterator](): Generator<TSX.RenderedComponent<T>, void, unknown>;
        indexOf(rendered: TSX.RenderedComponent<T> | T): 0 | -1;
        set<K extends T>(FragmentClass: new () => K, args: Omit<TSX.Props<K>, "fragmentList">): K;
        attach(rendered: TSX.RenderedComponent<T>): void;
        get(): TSX.RenderedComponent<T> | undefined;
        get instance(): T | undefined;
        detach(): void;
        destroy(): void;
        /** internal */
        [$remove](rendered: TSX.RenderedComponent<T>): boolean;
    }
    namespace Container {
        interface Props<T extends Fragment<any>> extends JSX.HTMLAttributes<HTMLDivElement> {
            nodeType?: string;
            fragmentList: AbstractList<T>;
            key: string;
            [Component.Children]?: undefined;
        }
    }
    class Container<T extends Fragment<any>> extends BasicComponent<Container.Props<T>> {
        private container;
        attachContainer(instance: HTMLDivElement): void;
        attachFragment(rendered: TSX.RenderedComponent<T>, at?: number | Node): void;
        render(): JSX.Element;
    }
}
export {};
