import { Component, VNode, ComponentChildren, Attributes, TSX } from "./TSX";

type DomElement = Element;
type DomSVGElement = SVGElement;

declare global {
	namespace Dom {
		type Element = DomElement;
		type SVGElement = DomSVGElement;
	}
}

declare global {
	namespace JSX {
		interface Element extends VNode {
		}

		interface ElementClass extends Component<any> {
		}

		interface ElementAttributesProperty {
			props: any;
		}

		interface ElementChildrenAttribute {
			[Component.Children]: any;
		}

		interface SVGAttributes<T extends Dom.SVGElement = Dom.SVGElement> extends HTMLAttributes<T> {
			accentHeight?: number | string;
			accumulate?: "none" | "sum";
			additive?: "replace" | "sum";
			alignmentBaseline?: "auto" | "baseline" | "before-edge" | "text-before-edge" | "middle" | "central" | "after-edge" | "text-after-edge" | "ideographic" | "alphabetic" | "hanging" | "mathematical" | "inherit";
			allowReorder?: "no" | "yes";
			alphabetic?: number | string;
			amplitude?: number | string;
			arabicForm?: "initial" | "medial" | "terminal" | "isolated";
			ascent?: number | string;
			attributeName?: string;
			attributeType?: string;
			autoReverse?: number | string;
			azimuth?: number | string;
			baseFrequency?: number | string;
			baselineShift?: number | string;
			baseProfile?: number | string;
			bbox?: number | string;
			begin?: number | string;
			bias?: number | string;
			by?: number | string;
			calcMode?: number | string;
			capHeight?: number | string;
			clip?: number | string;
			clipPath?: string;
			clipPathUnits?: number | string;
			clipRule?: number | string;
			colorInterpolation?: number | string;
			colorInterpolationFilters?: "auto" | "sRGB" | "linearRGB" | "inherit";
			colorProfile?: number | string;
			colorRendering?: number | string;
			contentScriptType?: number | string;
			contentStyleType?: number | string;
			cursor?: number | string;
			cx?: number | string;
			cy?: number | string;
			d?: string;
			decelerate?: number | string;
			descent?: number | string;
			diffuseConstant?: number | string;
			direction?: number | string;
			display?: number | string;
			divisor?: number | string;
			dominantBaseline?: number | string;
			dur?: number | string;
			dx?: number | string;
			dy?: number | string;
			edgeMode?: number | string;
			elevation?: number | string;
			enableBackground?: number | string;
			end?: number | string;
			exponent?: number | string;
			externalResourcesRequired?: number | string;
			fill?: string;
			fillOpacity?: number | string;
			fillRule?: "nonzero" | "evenodd" | "inherit";
			filter?: string;
			filterRes?: number | string;
			filterUnits?: number | string;
			floodColor?: number | string;
			floodOpacity?: number | string;
			focusable?: number | string;
			fontFamily?: string;
			fontSize?: number | string;
			fontSizeAdjust?: number | string;
			fontStretch?: number | string;
			fontStyle?: number | string;
			fontVariant?: number | string;
			fontWeight?: number | string;
			format?: number | string;
			from?: number | string;
			fx?: number | string;
			fy?: number | string;
			g1?: number | string;
			g2?: number | string;
			glyphName?: number | string;
			glyphOrientationHorizontal?: number | string;
			glyphOrientationVertical?: number | string;
			glyphRef?: number | string;
			gradientTransform?: string;
			gradientUnits?: string;
			hanging?: number | string;
			horizAdvX?: number | string;
			horizOriginX?: number | string;
			ideographic?: number | string;
			imageRendering?: number | string;
			in2?: number | string;
			in?: string;
			intercept?: number | string;
			k1?: number | string;
			k2?: number | string;
			k3?: number | string;
			k4?: number | string;
			k?: number | string;
			kernelMatrix?: number | string;
			kernelUnitLength?: number | string;
			kerning?: number | string;
			keyPoints?: number | string;
			keySplines?: number | string;
			keyTimes?: number | string;
			lengthAdjust?: number | string;
			letterSpacing?: number | string;
			lightingColor?: number | string;
			limitingConeAngle?: number | string;
			local?: number | string;
			markerEnd?: string;
			markerHeight?: number | string;
			markerMid?: string;
			markerStart?: string;
			markerUnits?: number | string;
			markerWidth?: number | string;
			mask?: string;
			maskContentUnits?: number | string;
			maskUnits?: number | string;
			mathematical?: number | string;
			mode?: number | string;
			numOctaves?: number | string;
			offset?: number | string;
			opacity?: number | string;
			operator?: number | string;
			order?: number | string;
			orient?: number | string;
			orientation?: number | string;
			origin?: number | string;
			overflow?: number | string;
			overlinePosition?: number | string;
			overlineThickness?: number | string;
			paintOrder?: number | string;
			panose1?: number | string;
			pathLength?: number | string;
			patternContentUnits?: string;
			patternTransform?: number | string;
			patternUnits?: string;
			pointerEvents?: number | string;
			points?: string;
			pointsAtX?: number | string;
			pointsAtY?: number | string;
			pointsAtZ?: number | string;
			preserveAlpha?: number | string;
			preserveAspectRatio?: string;
			primitiveUnits?: number | string;
			r?: number | string;
			radius?: number | string;
			refX?: number | string;
			refY?: number | string;
			renderingIntent?: number | string;
			repeatCount?: number | string;
			repeatDur?: number | string;
			requiredExtensions?: number | string;
			requiredFeatures?: number | string;
			restart?: number | string;
			result?: string;
			rotate?: number | string;
			rx?: number | string;
			ry?: number | string;
			scale?: number | string;
			seed?: number | string;
			shapeRendering?: number | string;
			slope?: number | string;
			spacing?: number | string;
			specularConstant?: number | string;
			specularExponent?: number | string;
			speed?: number | string;
			spreadMethod?: string;
			startOffset?: number | string;
			stdDeviation?: number | string;
			stemh?: number | string;
			stemv?: number | string;
			stitchTiles?: number | string;
			stopColor?: string;
			stopOpacity?: number | string;
			strikethroughPosition?: number | string;
			strikethroughThickness?: number | string;
			string?: number | string;
			stroke?: string;
			strokeDasharray?: string | number;
			strokeDashoffset?: string | number;
			strokeLinecap?: "butt" | "round" | "square" | "inherit";
			strokeLinejoin?: "miter" | "round" | "bevel" | "inherit";
			strokeMiterlimit?: string;
			strokeOpacity?: number | string;
			strokeWidth?: number | string;
			surfaceScale?: number | string;
			systemLanguage?: number | string;
			tableValues?: number | string;
			targetX?: number | string;
			targetY?: number | string;
			textAnchor?: string;
			textDecoration?: number | string;
			textLength?: number | string;
			textRendering?: number | string;
			to?: number | string;
			transform?: string;
			u1?: number | string;
			u2?: number | string;
			underlinePosition?: number | string;
			underlineThickness?: number | string;
			unicode?: number | string;
			unicodeBidi?: number | string;
			unicodeRange?: number | string;
			unitsPerEm?: number | string;
			vAlphabetic?: number | string;
			values?: string;
			vectorEffect?: number | string;
			version?: string;
			vertAdvY?: number | string;
			vertOriginX?: number | string;
			vertOriginY?: number | string;
			vHanging?: number | string;
			vIdeographic?: number | string;
			viewBox?: string;
			viewTarget?: number | string;
			visibility?: number | string;
			vMathematical?: number | string;
			widths?: number | string;
			wordSpacing?: number | string;
			writingMode?: number | string;
			x1?: number | string;
			x2?: number | string;
			x?: number | string;
			xChannelSelector?: string;
			xHeight?: number | string;
			xlinkActuate?: string;
			xlinkArcrole?: string;
			xlinkHref?: string;
			xlinkRole?: string;
			xlinkShow?: string;
			xlinkTitle?: string;
			xlinkType?: string;
			xmlBase?: string;
			xmlLang?: string;
			xmlns?: string;
			xmlnsXlink?: string;
			xmlSpace?: string;
			y1?: number | string;
			y2?: number | string;
			y?: number | string;
			yChannelSelector?: string;
			z?: number | string;
			zoomAndPan?: string;
		}

		interface PathAttributes {
			d: string;
		}

		interface EventHandler<E extends Event, T extends Dom.Element> {
			(event: E, element: T): void;
		}

		type ClipboardEventHandler<T extends Dom.Element> = EventHandler<ClipboardEvent, T>;
		type CompositionEventHandler<T extends Dom.Element> = EventHandler<CompositionEvent, T>;
		type DragEventHandler<T extends Dom.Element> = EventHandler<DragEvent, T>;
		type FocusEventHandler<T extends Dom.Element> = EventHandler<FocusEvent, T>;
		type KeyboardEventHandler<T extends Dom.Element> = EventHandler<KeyboardEvent, T>;
		type MouseEventHandler<T extends Dom.Element> = EventHandler<MouseEvent, T>;
		type TouchEventHandler<T extends Dom.Element> = EventHandler<TouchEvent, T>;
		type UIEventHandler<T extends Dom.Element> = EventHandler<UIEvent, T>;
		type WheelEventHandler<T extends Dom.Element> = EventHandler<WheelEvent, T>;
		type AnimationEventHandler<T extends Dom.Element> = EventHandler<AnimationEvent, T>;
		type TransitionEventHandler<T extends Dom.Element> = EventHandler<TransitionEvent, T>;
		type GenericEventHandler<T extends Dom.Element> = EventHandler<Event, T>;

		interface DOMAttributes<T extends Dom.Element> {
			// PreactDOMAttributes
			[Component.Children]?: ComponentChildren | object;
			dangerouslySetInnerHTML?: {
				__html: string;
			};

			// Image Events
			onLoad?: GenericEventHandler<T>;

			// Clipboard Events
			onCopy?: ClipboardEventHandler<T>;
			onCut?: ClipboardEventHandler<T>;
			onPaste?: ClipboardEventHandler<T>;

			// Composition Events
			onCompositionEnd?: CompositionEventHandler<T>;
			onCompositionStart?: CompositionEventHandler<T>;
			onCompositionUpdate?: CompositionEventHandler<T>;

			// Focus Events
			onFocus?: FocusEventHandler<T>;
			onBlur?: FocusEventHandler<T>;

			// Form Events
			onChange?: GenericEventHandler<T>;
			onInput?: GenericEventHandler<T>;
			onSearch?: GenericEventHandler<T>;
			onSubmit?: GenericEventHandler<T>;

			// Keyboard Events
			onKeyDown?: KeyboardEventHandler<T>;
			onKeyPress?: KeyboardEventHandler<T>;
			onKeyUp?: KeyboardEventHandler<T>;

			// Media Events
			onAbort?: GenericEventHandler<T>;
			onCanPlay?: GenericEventHandler<T>;
			onCanPlayThrough?: GenericEventHandler<T>;
			onDurationChange?: GenericEventHandler<T>;
			onEmptied?: GenericEventHandler<T>;
			onEncrypted?: GenericEventHandler<T>;
			onEnded?: GenericEventHandler<T>;
			onLoadedData?: GenericEventHandler<T>;
			onLoadedMetadata?: GenericEventHandler<T>;
			onLoadStart?: GenericEventHandler<T>;
			onPause?: GenericEventHandler<T>;
			onPlay?: GenericEventHandler<T>;
			onPlaying?: GenericEventHandler<T>;
			onProgress?: GenericEventHandler<T>;
			onRateChange?: GenericEventHandler<T>;
			onSeeked?: GenericEventHandler<T>;
			onSeeking?: GenericEventHandler<T>;
			onStalled?: GenericEventHandler<T>;
			onSuspend?: GenericEventHandler<T>;
			onTimeUpdate?: GenericEventHandler<T>;
			onVolumeChange?: GenericEventHandler<T>;
			onWaiting?: GenericEventHandler<T>;

			// MouseEvents
			onClick?: MouseEventHandler<T>;
			onContextMenu?: MouseEventHandler<T>;
			onDblClick?: MouseEventHandler<T>;
			onDrag?: DragEventHandler<T>;
			onDragEnd?: DragEventHandler<T>;
			onDragEnter?: DragEventHandler<T>;
			onDragExit?: DragEventHandler<T>;
			onDragLeave?: DragEventHandler<T>;
			onDragOver?: DragEventHandler<T>;
			onDragStart?: DragEventHandler<T>;
			onDrop?: DragEventHandler<T>;
			onMouseDown?: MouseEventHandler<T>;
			onMouseEnter?: MouseEventHandler<T>;
			onMouseLeave?: MouseEventHandler<T>;
			onMouseMove?: MouseEventHandler<T>;
			onMouseOut?: MouseEventHandler<T>;
			onMouseOver?: MouseEventHandler<T>;
			onMouseUp?: MouseEventHandler<T>;

			// Selection Events
			onSelect?: GenericEventHandler<T>;

			// Touch Events
			onTouchCancel?: TouchEventHandler<T>;
			onTouchEnd?: TouchEventHandler<T>;
			onTouchMove?: TouchEventHandler<T>;
			onTouchStart?: TouchEventHandler<T>;

			// UI Events
			onScroll?: UIEventHandler<T>;

			// Wheel Events
			onWheel?: WheelEventHandler<T>;

			// Animation Events
			onAnimationStart?: AnimationEventHandler<T>;
			onAnimationEnd?: AnimationEventHandler<T>;
			onAnimationIteration?: AnimationEventHandler<T>;

			// Transition Events
			onTransitionEnd?: TransitionEventHandler<T>;
		}

		interface HTMLAttributes<T extends Dom.Element = Dom.Element> extends Attributes<any>, DOMAttributes<T> {
			// Standard HTML Attributes
			accept?: string;
			acceptCharset?: string;
			accessKey?: string;
			action?: string;
			allowFullScreen?: boolean;
			allowTransparency?: boolean;
			alt?: string;
			async?: boolean;
			autocomplete?: string;
			autofocus?: boolean;
			autoPlay?: boolean;
			capture?: boolean;
			cellPadding?: number | string;
			cellSpacing?: number | string;
			charSet?: string;
			challenge?: string;
			checked?: boolean;
			class?: string | { [K: string]: boolean | undefined; } | (string | false | undefined | null)[];
			className?: string | { [K: string]: boolean | undefined; } | (string | false | undefined | null)[];
			cols?: number;
			colSpan?: number;
			content?: string;
			contentEditable?: boolean;
			contextMenu?: string;
			controls?: boolean;
			coords?: string;
			crossOrigin?: string;
			data?: string;
			dateTime?: string;
			default?: boolean;
			defer?: boolean;
			dir?: string;
			disabled?: boolean;
			download?: any;
			draggable?: boolean;
			encType?: string;
			form?: string;
			formAction?: string;
			formEncType?: string;
			formMethod?: string;
			formNoValidate?: boolean;
			formTarget?: string;
			frameBorder?: number | string;
			headers?: string;
			height?: number | string;
			hidden?: boolean;
			high?: number;
			href?: string;
			hrefLang?: string;
			for?: string;
			httpEquiv?: string;
			icon?: string;
			id?: string;
			inputMode?: string;
			integrity?: string;
			is?: string;
			keyParams?: string;
			keyType?: string;
			kind?: string;
			label?: string;
			lang?: string;
			list?: string;
			loop?: boolean;
			low?: number;
			manifest?: string;
			marginHeight?: number;
			marginWidth?: number;
			max?: number | string;
			maxLength?: number;
			media?: string;
			mediaGroup?: string;
			method?: string;
			min?: number | string;
			minLength?: number;
			multiple?: boolean;
			muted?: boolean;
			name?: string;
			noValidate?: boolean;
			open?: boolean;
			optimum?: number;
			pattern?: string;
			placeholder?: string;
			poster?: string;
			preload?: string;
			radioGroup?: string;
			readOnly?: boolean;
			rel?: string;
			required?: boolean;
			role?: string;
			rows?: number;
			rowSpan?: number;
			sandbox?: string;
			scope?: string;
			scoped?: boolean;
			scrolling?: string;
			seamless?: boolean;
			selected?: boolean;
			shape?: string;
			size?: number;
			sizes?: string;
			slot?: string;
			span?: number;
			spellCheck?: boolean;
			src?: string;
			srcset?: string;
			srcDoc?: string;
			srcLang?: string;
			srcSet?: string;
			start?: number;
			step?: number | string;
			style?: any;
			summary?: string;
			tabIndex?: number;
			target?: string;
			title?: string;
			type?: string;
			useMap?: string;
			value?: string | string[] | number;
			width?: number | string;
			wmode?: string;
			wrap?: string;

			// RDFa Attributes
			about?: string;
			datatype?: string;
			inlist?: any;
			prefix?: string;
			property?: string;
			resource?: string;
			typeof?: string;
			vocab?: string;

			/* 
			TODO: 
				[K: `store-${string}`]: any;
			*/

			raw?: boolean;
		}

		interface IntrinsicElements {
			// HTML
			a: HTMLAttributes<HTMLAnchorElement>;
			abbr: HTMLAttributes;
			address: HTMLAttributes;
			area: HTMLAttributes<HTMLAreaElement>;
			article: HTMLAttributes;
			aside: HTMLAttributes;
			audio: HTMLAttributes<HTMLAudioElement>;
			b: HTMLAttributes;
			base: HTMLAttributes<HTMLBaseElement>;
			bdi: HTMLAttributes;
			bdo: HTMLAttributes;
			big: HTMLAttributes;
			blockquote: HTMLAttributes<HTMLQuoteElement>;
			body: HTMLAttributes<HTMLBodyElement>;
			br: HTMLAttributes<HTMLBRElement>;
			button: HTMLAttributes<HTMLButtonElement>;
			canvas: HTMLAttributes<HTMLCanvasElement>;
			caption: HTMLAttributes<HTMLTableCaptionElement>;
			cite: HTMLAttributes;
			code: HTMLAttributes;
			col: HTMLAttributes<HTMLTableColElement>;
			colgroup: HTMLAttributes<HTMLTableColElement>;
			data: HTMLAttributes<HTMLDataElement>;
			datalist: HTMLAttributes<HTMLDataListElement>;
			dd: HTMLAttributes;
			del: HTMLAttributes<HTMLModElement>;
			details: HTMLAttributes<HTMLDetailsElement>;
			dfn: HTMLAttributes;
			// dialog: HTMLAttributes<HTMLDialogElement>;
			div: HTMLAttributes<HTMLDivElement>;
			dl: HTMLAttributes<HTMLDListElement>;
			dt: HTMLAttributes;
			em: HTMLAttributes;
			embed: HTMLAttributes<HTMLEmbedElement>;
			fieldset: HTMLAttributes<HTMLFieldSetElement>;
			figcaption: HTMLAttributes;
			figure: HTMLAttributes;
			footer: HTMLAttributes;
			form: HTMLAttributes<HTMLFormElement>;
			h1: HTMLAttributes<HTMLHeadingElement>;
			h2: HTMLAttributes<HTMLHeadingElement>;
			h3: HTMLAttributes<HTMLHeadingElement>;
			h4: HTMLAttributes<HTMLHeadingElement>;
			h5: HTMLAttributes<HTMLHeadingElement>;
			h6: HTMLAttributes<HTMLHeadingElement>;
			head: HTMLAttributes<HTMLHeadElement>;
			header: HTMLAttributes;
			hr: HTMLAttributes<HTMLHRElement>;
			html: HTMLAttributes<HTMLHtmlElement>;
			i: HTMLAttributes;
			iframe: HTMLAttributes<HTMLIFrameElement>;
			img: HTMLAttributes<HTMLImageElement>;
			input: HTMLAttributes<HTMLInputElement>;
			ins: HTMLAttributes<HTMLModElement>;
			kbd: HTMLAttributes;
			keygen: HTMLAttributes;
			label: HTMLAttributes<HTMLLabelElement>;
			legend: HTMLAttributes<HTMLLegendElement>;
			li: HTMLAttributes<HTMLLIElement>;
			link: HTMLAttributes<HTMLLinkElement>;
			main: HTMLAttributes;
			map: HTMLAttributes<HTMLMapElement>;
			mark: HTMLAttributes;
			menu: HTMLAttributes<HTMLMenuElement>;
			menuitem: HTMLAttributes;
			meta: HTMLAttributes<HTMLMetaElement>;
			meter: HTMLAttributes<HTMLMeterElement>;
			nav: HTMLAttributes;
			noscript: HTMLAttributes;
			object: HTMLAttributes<HTMLObjectElement>;
			ol: HTMLAttributes<HTMLOListElement>;
			optgroup: HTMLAttributes<HTMLOptGroupElement>;
			option: HTMLAttributes<HTMLOptionElement>;
			output: HTMLAttributes<HTMLOutputElement>;
			p: HTMLAttributes<HTMLParagraphElement>;
			param: HTMLAttributes<HTMLParamElement>;
			picture: HTMLAttributes<HTMLPictureElement>;
			pre: HTMLAttributes<HTMLPreElement>;
			progress: HTMLAttributes<HTMLProgressElement>;
			q: HTMLAttributes<HTMLQuoteElement>;
			rp: HTMLAttributes;
			rt: HTMLAttributes;
			ruby: HTMLAttributes;
			s: HTMLAttributes;
			samp: HTMLAttributes;
			script: HTMLAttributes<HTMLScriptElement>;
			section: HTMLAttributes;
			select: HTMLAttributes<HTMLSelectElement>;
			slot: HTMLAttributes<HTMLSlotElement>;
			small: HTMLAttributes;
			source: HTMLAttributes<HTMLSourceElement>;
			span: HTMLAttributes<HTMLSpanElement>;
			strong: HTMLAttributes;
			style: HTMLAttributes<HTMLStyleElement>;
			sub: HTMLAttributes;
			summary: HTMLAttributes;
			sup: HTMLAttributes;
			table: HTMLAttributes<HTMLTableElement>;
			tbody: HTMLAttributes<HTMLTableSectionElement>;
			td: HTMLAttributes<HTMLTableCellElement>;
			textarea: HTMLAttributes<HTMLTextAreaElement>;
			tfoot: HTMLAttributes<HTMLTableSectionElement>;
			th: HTMLAttributes<HTMLTableCellElement>;
			thead: HTMLAttributes<HTMLTableSectionElement>;
			time: HTMLAttributes<HTMLTimeElement>;
			title: HTMLAttributes<HTMLTitleElement>;
			tr: HTMLAttributes<HTMLTableRowElement>;
			track: HTMLAttributes<HTMLTrackElement>;
			u: HTMLAttributes;
			ul: HTMLAttributes<HTMLUListElement>;
			var: HTMLAttributes;
			video: HTMLAttributes<HTMLVideoElement>;
			wbr: HTMLAttributes;

			//SVG
			animate: SVGAttributes<SVGAnimateElement>;
			animateMotion: SVGAttributes<SVGAnimateMotionElement>;
			animateTransform: SVGAttributes<SVGAnimateTransformElement>;
			circle: SVGAttributes<SVGCircleElement>;
			clipPath: SVGAttributes<SVGClipPathElement>;
			defs: SVGAttributes<SVGDefsElement>;
			desc: SVGAttributes<SVGDescElement>;
			ellipse: SVGAttributes<SVGEllipseElement>;
			feBlend: SVGAttributes<SVGFEBlendElement>;
			feColorMatrix: SVGAttributes<SVGFEColorMatrixElement>;
			feComponentTransfer: SVGAttributes<SVGFEComponentTransferElement>;
			feComposite: SVGAttributes<SVGFECompositeElement>;
			feConvolveMatrix: SVGAttributes<SVGFEConvolveMatrixElement>;
			feDiffuseLighting: SVGAttributes<SVGFEDiffuseLightingElement>;
			feDisplacementMap: SVGAttributes<SVGFEDisplacementMapElement>;
			feDistantLight: SVGAttributes<SVGFEDistantLightElement>;
			feDropShadow: SVGAttributes<SVGFEDropShadowElement>;
			feFlood: SVGAttributes<SVGFEFloodElement>;
			feFuncA: SVGAttributes<SVGFEFuncAElement>;
			feFuncB: SVGAttributes<SVGFEFuncBElement>;
			feFuncG: SVGAttributes<SVGFEFuncGElement>;
			feFuncR: SVGAttributes<SVGFEFuncRElement>;
			feGaussianBlur: SVGAttributes<SVGFEGaussianBlurElement>;
			feImage: SVGAttributes<SVGFEImageElement>;
			feMerge: SVGAttributes<SVGFEMergeElement>;
			feMergeNode: SVGAttributes<SVGFEMergeNodeElement>;
			feMorphology: SVGAttributes<SVGFEMorphologyElement>;
			feOffset: SVGAttributes<SVGFEOffsetElement>;
			fePointLight: SVGAttributes<SVGFEPointLightElement>;
			feSpecularLighting: SVGAttributes<SVGFESpecularLightingElement>;
			feSpotLight: SVGAttributes<SVGFESpotLightElement>;
			feTile: SVGAttributes<SVGFETileElement>;
			feTurbulence: SVGAttributes<SVGFETurbulenceElement>;
			filter: SVGAttributes<SVGFilterElement>;
			foreignObject: SVGAttributes<SVGForeignObjectElement>;
			g: SVGAttributes<SVGGElement>;
			image: SVGAttributes<SVGImageElement>;
			line: SVGAttributes<SVGLineElement>;
			linearGradient: SVGAttributes<SVGLinearGradientElement>;
			marker: SVGAttributes<SVGMarkerElement>;
			mask: SVGAttributes<SVGMaskElement>;
			metadata: SVGAttributes<SVGMetadataElement>;
			mpath: SVGAttributes<SVGMPathElement>;
			path: SVGAttributes<SVGPathElement>;
			pattern: SVGAttributes<SVGPatternElement>;
			polygon: SVGAttributes<SVGPolygonElement>;
			polyline: SVGAttributes<SVGPolylineElement>;
			radialGradient: SVGAttributes<SVGRadialGradientElement>;
			rect: SVGAttributes<SVGRectElement>;
			set: SVGAttributes<SVGSetElement>;
			stop: SVGAttributes<SVGStopElement>;
			svg: SVGAttributes<SVGSVGElement>;
			switch: SVGAttributes<SVGSwitchElement>;
			symbol: SVGAttributes<SVGSymbolElement>;
			text: SVGAttributes<SVGTextElement>;
			textPath: SVGAttributes<SVGTextPathElement>;
			tspan: SVGAttributes<SVGTSpanElement>;
			use: SVGAttributes<SVGUseElement>;
			view: SVGAttributes<SVGViewElement>;

			// TODO: overlap with normal elements
			// a: SVGAttributes<SVGAElement>;
			// script: SVGAttributes<SVGScriptElement>;
			// style: SVGAttributes<SVGStyleElement>;
			// title: SVGAttributes<SVGTitleElement>;

			inline: {
				renderer: TSX.Renderer;
				persistent?: boolean;
				[Component.Children]?: undefined;
			};

			/** Raw elements require key, ref and can not specify children using TSX */
			raw: HTMLAttributes<HTMLDivElement> & {
				key: string | number;
				ref: (instance: HTMLDivElement) => void;
				[Component.Children]?: undefined;
			};
		}
	}
}
